<template>
	<div class="qra">
		<div class="qra__items">
			<qra-requirement v-for="(item, i) in items" :key="i" :data="item" />
		</div>

		<qra-problems-panel :problems="problems" ref="panel" />
		<qra-overlay ref="overlay" />
	</div>
</template>

<script>
export default {
	data() {
		return {
			is_loading: true,


			/**
			 * The main array of problematic parts of our document.
			 */

			items: []
		}
	},

	computed: {
		problems() {
			let problems = [];

			this.items.map((req) => {
				req.parts.filter(part => part.type == 'highlight').map(part => {
					problems.push(part);
				});
			});

			return problems;
		}
	},

	mounted() {

		/**
		 * Unset storage state
		 */
		this.$store.commit('parts/unset');

		/**
		 * As soon as component is initiated
		 * we can load the data from API
		 */
		this.load();

	},

	methods: {
		load() {
			this.is_loading = true;

			/**
			 * Here we're simulating the loading from API. Cause we don't have API, 
			 * we're setting timer for 2 seconds and waiting for completion. API call would look like:
			 * this.$axios.get('/api/v1/requirements/{requirement_id}/mistakes').then(...)
			 */

			setTimeout(() => {
				this.items = [
					{
						id: 1,
						title: 'Q2.22',
						parts: [
							{
								id: 1,
								requirement_id: 1,
								type: 'text',
								value: 'If any component of the system goes out of control, the broken parts (motion detector, radar, '
							},
							{
								id: 2,
								requirement_id: 1,
								type: 'highlight',
								value: 'etc.',
								color: 'danger',
								tip: {
									title: 'Vague words',
									text: 'Restate the requirement with vague words as one or more requirements with clear and definite intent.'
								},
							},
							{
								id: 3,
								requirement_id: 1,
								type: 'text',
								value: ') should be replaced by the authorised service provider. If this is not possible, the broken parts should be replaces with '
							},
							{
								id: 4,
								requirement_id: 1,
								type: 'highlight',
								value: 'some additional stuff',
								color: 'error',
								tip: {
									title: 'Immesuarable quantifications',
									text: 'Use an appropriate form of describing qantitive specifications. Be specific and clear.',
									suggest: ['some other form']
								},
							},
							{	
								id: 5,
								requirement_id: 1,
								type: 'text',
								value: ' from the storage of used parts.'
							},
						]
					},
					{
						id: 2,
						title: 'Q2.23',
						parts: [
							{
								id: 6,
								requirement_id: 2,
								type: 'text',
								value: 'Maecenas sed diam eget '
							},
							{
								id: 7,
								requirement_id: 2,
								type: 'highlight',
								value: 'risus varius',
								color: 'danger',
								tip: {
									title: 'Vague words',
									text: 'Restate the requirement with vague words as one or more requirements with clear and definite intent.'
								},
							},
							{
								id: 8,
								requirement_id: 2,
								type: 'text',
								value: ' blandit sit amet non magna. Vivamus sagittis lacus vel '
							},
							{
								id: 9,
								requirement_id: 2,
								type: 'highlight',
								value: 'augue laoreet',
								color: 'error',
								tip: {
									title: 'Aenean eu leo quam.',
									text: 'Pellentesque ornare sem lacinia quam venenatis vestibulum.',
									suggest: ['one more example']
								},
							},
							{	
								id: 10,
								requirement_id: 2,
								type: 'text',
								value: ' rutrum faucibus dolor auctor. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum. Nullam quis risus eget urna mollis ornare vel eu leo.'
							},
						]
					},
					{
						id: 3,
						title: 'Q2.24',
						parts: [
							{
								id:11,
								requirement_id: 3,
								type: 'text',
								value: 'Aenean eu leo quam. Pellentesque '
							},
							{
								id: 12,
								requirement_id: 3,
								type: 'highlight',
								value: 'ornare sem lacinia quam',
								color: 'danger',
								tip: {
									title: 'Aenean eu leo quam.',
									text: 'Pellentesque ornare sem lacinia quam venenatis vestibulum.',
									suggest: ['some other text', 'another one']
								},
							},
							{
								id: 13,
								requirement_id: 3,
								type: 'text',
								value: ' vestibulum. Maecenas sed diam. Maecenas sed diam eget risus varius blandit sit amet non magna. Etiam porta sem malesuada magna mollis euismod. '
							},
							{
								id: 14,
								requirement_id: 3,
								type: 'highlight',
								value: 'lacinia quam',
								color: 'error',
								tip: {
									title: 'Vague words',
									text: 'Restate the requirement with vague words as one or more requirements with clear and definite intent.'
								},
							},
							{	
								id: 15,
								requirement_id: 3,
								type: 'text',
								value: ' vestibulum. Maecenas sed diam.'
							},
						]
					}
				];
			}, 1);
		}
	}
}
</script>

<style lang="scss">
* {
	padding: 0px;
	margin: 0px;
	position: relative;
	-webkit-font-smoothing: antialiased;
	box-sizing: border-box;
}

body {
	font-size: 14px;
	font-family: -apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,Oxygen-Sans,Ubuntu,Cantarell,"Helvetica Neue",sans-serif;
}

.qra {
	background-color: #f6f6f6;
	min-height: 100vh;
	padding: 80px 6%;
	&__items {
		max-width: 800px;
		background-color: #fff;
		padding: 10px 0px;
		margin: 0px auto;
		border-radius: 12px;
		box-shadow: 0px 15px 40px rgba(0,0,0,.05);
	}
}
</style>
